<?php

require_once('db.inc.php');

function login($user, $pass)
{
   $ret = db_escape(array(&$user,
                          &$pass));

   if(is_string($ret)) {
      return;
   }

   $sql  = "SELECT `user`, ";
   $sql .=        "`level` ";
   $sql .= "FROM `user` ";
   $sql .= "WHERE (`user` = '$user') AND ";
   $sql .=       "(`pass` = SHA1('$pass'))";

   $ret = db_query($sql);

   if(!isset($ret[0]->user)) {
      return;
   }

   $_SESSION['authuser'] = $ret[0]->user;
   $_SESSION['authlevel'] = $ret[0]->level;

   return;
}

function logout()
{
   unset($_SESSION['authlevel']);

   return session_destroy();
}

function checklevel($level)
{
   if(isset($_SESSION['authlevel']) && (($_SESSION['authlevel'] & $level) == $level)) {
      return true;
   }

   return false;
}

function search($user, $action, $desc, $begin, $end, $order)
{
   $ret = db_escape(array(&$user,
                          &$action,
                          &$desc,
                          &$begin,
                          &$end,
                          &$order));

   if(is_string($ret)) {
      return;
   }

   $sql  = "SELECT `user`, ";
   $sql .=        "`action`, ";
   $sql .=        "`desc`, ";
   $sql .=        "`timestamp` ";
   $sql .= "FROM `trace` ";
   $sql .= "WHERE 1 ";
   $sql .= ($user ? " AND `user` = '$user'" : '');
   $sql .= ($action ? " AND `action` = '$action'" : '');
   $sql .= ($desc ? " AND `desc` = '$desc'" : '');
   $sql .= ($begin ? " AND `timestamp` >= '$begin'" : '');
   $sql .= ($end ? " AND `timestamp` <= '$end'" : '');

   $ret = db_query($sql);

   if($ret === false) {
      return $ret;
   }

   $order = ($order ? $order : 'timestamp');

   $lambda = create_function('$a, $b',
                             'return strcasecmp($a->'.$order.', $b->'.$order.');');

   $rlambda = create_function('$a, $b',
                              'return (-1 * strcasecmp($a->'.$order.', $b->'.$order.'));');

   if($order == 'timestamp') {
      usort($ret, $rlambda);
   } else {
      usort($ret, $lambda);
   }

   return $ret;
}

function getparam()
{
   $sql  = "SELECT DISTINCT `user`, ";
   $sql .=                 "`action`, ";
   $sql .=                 "`desc` ";
   $sql .= "FROM `trace`";

   $ret = db_query($sql);

   if(is_string($ret)) {
      return $ret;
   } else if($ret === false) {
      return false;
   }

   foreach(array('user', 'action', 'desc') as $field) {
      $tmp->$field = array();
      foreach($ret as $r) {
         array_push($tmp->$field, $r->$field);
      }
      $tmp->$field = array_unique($tmp->$field);
      sort($tmp->$field);
   }

   $ret = $tmp;

   return $ret;
}

define('AL_VIEW', 0x01);   // viewer access
define('AL_TECH', 0x02);   // technician access
define('AL_SERV', 0x04);   // server access
define('AL_ADMN', 0x80);   // administrator access

?>
